def fib(number) {
  if (number < 2)
    return number
  else
    return fib(number - 1) + fib(number - 2)
}

cache = [:]

def fibMemoized(number) {
  if (number < 2) return new BigInteger(number)
  
  if(!cache.containsKey(number))
    cache.put(number, fibMemoized(number -1) + fibMemoized(number - 2))
  cache.get(number)
}

def fibMemoized2
fibMemoized2 = { number ->
  number < 2 ? new BigInteger(number) : fibMemoized2(number - 1) + fibMemoized2(number - 2)
}.memoize()

def timeIt(code) {
  def start = System.nanoTime()
  def result = code()
  def end = System.nanoTime()
  println "Time taken ${(end - start)/1.0e9}"
  result
}

println timeIt { fib(40) }
println timeIt { fibMemoized(400) }
println timeIt { fibMemoized2(400) }