def timeIt(block : Unit => BigInt) = {
  val start = System.nanoTime
  val result = block()
  val end = System.nanoTime
  println(result)
  println("Time taken " + (end - start)/1.0e9)
}

def fib(number : Int) : BigInt = {
  if (number < 2)
    BigInt(number)
  else
    fib(number - 1) + fib(number - 2)
}

def fibMemoized(number : Int) = {
  def fibImpl(cache : List[BigInt], number : Int) : List[BigInt] = {
    number match {
      case _ if cache.size > number => cache
      case _ =>
        val newCache = fibImpl(fibImpl(cache, number - 1), number - 2)
        newCache ::: List(newCache(number - 1) + newCache(number - 2))
    }
  }
  
  fibImpl(List(0, 1), number)(number)
}

timeIt { _ => fib(40) }

timeIt { _ => fibMemoized(40) }
