def produce(n : Int, produced : Int) : Int = {
  if (n == 0)
    produced
  else
    consume(n, produced + 1)
}

def consume(n : Int, produced : Int) : Int = {
  if (n == 0)
    0
  else 
    produce(n - 1, produced)
}

try {
  println(produce(100000, 0))
} catch {
  case ex => println(ex)
}

import scala.util.control.TailCalls._

def produce1(n : Int, produced : Int) : TailRec[Int] = {
  if (n == 0)
    done(produced)
  else
    tailcall(consume1(n, produced + 1))
}

def consume1(n : Int, produced : Int) : TailRec[Int] = {
  if (n == 0)
    done(0)
  else 
    tailcall(produce1(n - 1, produced))
}

println(produce1(100000, 0).result)